Please use the Apache issue tracking system for new NetBeans issues (https://issues.apache.org/jira/projects/NETBEANS0/issues) !!
Bug 91277 - Define new default shorcuts (+shortcu sets)
Define new default shorcuts (+shortcu sets)
Status: RESOLVED FIXED
Product: ide
Classification: Unclassified
Component: Code
6.x
All All
: P1 (vote)
: 6.x
Assigned To: Ondrej Langr
issues@ide
plan60
: UI
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2006-12-19 14:13 UTC by Petr Hrebejk
Modified: 2007-07-20 16:18 UTC (History)
8 users (show)

See Also:
Issue Type: DEFECT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Petr Hrebejk 2006-12-19 14:13:26 UTC
There are lot of complaints about current set of shortcuts (not logical, hard to
learn, does not mimic any other IDE, ...)

We probably should create new default set of shortcuts for NetBeans. It would
also be nice to create set of shorctuts which mimic other products as close as
possible (VisualStudio, Eclipse, IDE, JBuilder, Emacs, to name the most
important ones.)
Comment 1 shemnon 2007-02-20 17:04:15 UTC
Can we add a default shortcut for save all?  ctrl+shift+S seems to be a common
one I have seen for those.
Comment 2 Petr Nejedly 2007-06-18 14:30:15 UTC
Sorry, but I can't agree with the initial statement.
In the situation where we have hundreds of thousands of active users, reassigning commonly used shortcuts is braindead.
Sure there are some complaints, especially from the newcomers. Sure it would please newcomers to find familiar
shortcuts, but the cost is just too high. If we change the defaults, we're going to upset more current users than we're
going to gain anew by this change.
Comment 3 jrojcek 2007-06-18 15:42:13 UTC
Implemented as planned.
Comment 4 Petr Hrebejk 2007-06-18 21:56:55 UTC
Reopening as P1 defect. I think we need more discussion about what should be the default.

Peter's commnet is valid we probably may loose more users than we gain.

BTW the NetBeans 5.5 profile is reported to be crappy.
Comment 5 jrojcek 2007-06-19 10:04:26 UTC
There's no point in changing shortcuts if we don't make it the default. 

Maybe we can automatically select 5.5 profile for those upgrading from previous IDE versions.

Comment 6 _ ttran 2007-06-19 10:19:19 UTC
when in doubt ask the users, in the installer or at first start time.  Visual Studio did it in the past
Comment 7 Ondrej Langr 2007-06-19 10:43:57 UTC
First, a lot of shortcuts HAVE TO BE CHANGED for 6.0 compared to 5.5 anyway. These are Alt + Something shortcuts,
because they're reserved for mnemonics. Then Ctrl + Alt shortcuts because they're used for AltGr and national
characters. Plus shortcuts for some individual actions such as comment/uncomment, etc.. 
So the change, forcing users to learn some new shortcuts will be there anyway.

I don't agree that we may loose users due to change of default profile, we may upset a few, but only before they realize
they can easily switch to the old profile. Given that both profiles would change (see my first paragraph), some may
actually realize that they'll rather go with the new profile.

As for current users, they always have the option to choose (new profile/old profile/own mappings). Let aside the
question whether they know about the option, this is  something we need to work on (maybe welcome screen would be a good
place to advertise that there's a possibility to switch back to the old profile?). 

Further, if we do not change the default profile, we already almost run out of easy (ctrl + something) shortcuts. This
means that there will be serious problems in the future to assign good shortcuts even for important and to be frequently
used new actions!
Comment 8 Petr Nejedly 2007-06-19 15:33:18 UTC
> "HAVE TO BE CHANGED"
Who said that? Current shortcuts work OK for most* of the users.

It's not the users that need all Alt+* _reserved_ for top menu mnemonics, it's only you. You're just trying to make your
work easier. Well, you want Alt+G so you can assign it to "&Go to" (currently funny but usable "&Navigate")? Who's gonna
use that? All the actions in that menu have their own direct shortcuts, and while it takes time to learn them, users can
live without the mnemonic later. And for rarely used actions, mouse (or other menu access path, like F10) is OK. 

Ctrl+Alt is different topic. So far I had no knowledge about the problem as:
1. I very rarely use national keyboard while in the IDE. This still poses larger problem for general platform though.
2. Everything works perfectly for me under Linux. Ctrl+Alt != AltGr. But today I learned that for (and only for)
national keyboards on Windows, Ctrl+Alt == AltGr. Oops, big usability problem for Windows (not for NB on Windows, for
Windows as such) but nobody seems really concerned.

Your second paragraph contradict itself. You claim that they can switch to the old profile, while stating in the next
sentence that you're going to cripple the old one as well!

In fourth paragraph, you claim you need easy shortcuts for important and frequently used actions, but you're doing
exactly the opposite with the new shortcut set. One of the biggest editor productivity boosters (prev/next matching
word) lost their nice Ctrl+K/L shortcuts and were given much harder Alt+Shift+K/L.

*) No shortcut scheme could ever work for everybody, the difference is having 50 complaining people in 1.000 newcomming
bloggers and 50 complaining people in 300.000 estabilished users.
Comment 9 Ondrej Langr 2007-06-19 17:03:06 UTC
Thanks for your feedback!

>> "HAVE TO BE CHANGED"
> Who said that? Current shortcuts work OK for most* of the users.
Please see below.

> It's not the users that need all Alt+* _reserved_ for top menu mnemonics, it's only you. You're just trying to make your
> work easier. Well, you want Alt+G so you can assign it to "&Go to" (currently funny but usable "&Navigate")? Who's gonna
> use that? All the actions in that menu have their own direct shortcuts, and while it takes time to learn them, users can
> live without the mnemonic later. And for rarely used actions, mouse (or other menu access path, like F10) is OK. 

Alt keys have to be reserved because of localisations. Unless you know names of all main menu items for all possible
languages NetBeans could be translated to, you need to reserve all Alt + * shortcuts.
So .. yes, it will make my work easier in the future. But it will also make work of many people who take care of
localisations easier as they will not have to think about clashes. And, at the end, it will make work easier for users
who will not experience these clashes (for example of such clash see IZ103005). 

> Ctrl+Alt is different topic. So far I had no knowledge about the problem as:
> 1. I very rarely use national keyboard while in the IDE. This still poses larger problem for general platform though.
> 2. Everything works perfectly for me under Linux. Ctrl+Alt != AltGr. But today I learned that for (and only for)
> national keyboards on Windows, Ctrl+Alt == AltGr. Oops, big usability problem for Windows (not for NB on Windows, for
> Windows as such) but nobody seems really concerned.

Some call it bug, some call it feature :). There are some issues regarding this, e.g. 64795.
IMO we can't just tell users: "sorry, it is windows and we can't do anything about it".

> Your second paragraph contradict itself. You claim that they can switch to the old profile, while stating in the next
> sentence that you're going to cripple the old one as well!

The 'crippling' consists of quite a few changes which have been introduced during the development cycle, before the new
keymap profile was implemented. The reasons usually were:

  1) shortcuts needed for new actions - no changes, just shortcuts added
  2) reservation of Alt + * shortcuts mentioned above
  3) removal of Ctrl + Alt + * mentioned above

I actually do not insist on implementing these changes to the old profile. If you want to keep the old profile as it was
in nb5.5, i'm fine with that. But it would mean reverting many changes already done during the development cycle.

> In fourth paragraph, you claim you need easy shortcuts for important and frequently used actions, but you're doing
> exactly the opposite with the new shortcut set. One of the biggest editor productivity boosters (prev/next matching
> word) lost their nice Ctrl+K/L shortcuts and were given much harder Alt+Shift+K/L.

As you said, no keymap scheme works for everybody, that's why we have customization.
Comment 10 rafaeldff 2007-07-01 23:13:43 UTC
I personally don't have a problem with 6.0 altering the shortcuts, but the shortcuts.pdf document (accessible from the
Help menu) should reflect those changes, at least on milestone builds. On M10 the pdf still has old shortcuts (ALT+O for
Go To Source and so on).
Comment 11 sreimers 2007-07-06 19:26:17 UTC
What about Shurtcuts and international keyboards? 
E.g. typing CTRL-/ or CTRL-\ on a german keyboard does not work,
 since you need to press other modifiers as well. 

Is this a task for the translation teams? 
Solution? 
Any hints would be really appreciated.
Comment 12 jrojcek 2007-07-18 15:55:29 UTC
The new default shortcuts are implemented. There's still a few issues tracked in the issuezilla, but the main part is done.

Reassigning to Ondrej who designed the new shortcuts and lead the whole effort (which was huge!). Please close this issue as fixed. Thanks a lot!
Comment 13 Ondrej Langr 2007-07-20 16:18:21 UTC
As Jano said, the main part is done. Please track other problems with the keymap in separate issues.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo